#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# imports.
import os, sys, requests, ast, json, pathlib, glob, platform, subprocess, pexpect, random

# inc imports.
from fil3s import Files, Formats
from r3sponse import r3sponse
import cl1, syst3m, ssht00ls

# source.
ALIAS = "sshmount"
SOURCE_NAME = "sshmount"
SOURCE_PATH = syst3m.defaults.get_source_path(__file__, back=3)
BASE = syst3m.defaults.get_source_path(SOURCE_PATH)
OS = syst3m.defaults.check_operating_system(supported=["linux", "osx"])
syst3m.defaults.check_alias(alias=ALIAS, executable=f"{SOURCE_PATH}")

# universal variables.
OWNER = os.environ.get("USER")
GROUP = "root"
HOME_BASE = "/home/"
HOME = f"/home/{os.environ.get('USER')}/"
MEDIA = f"/media/{os.environ.get('USER')}/"
if OS in ["osx"]: 
	HOME_BASE = "/Users/"
	HOME = f"/Users/{os.environ.get('USER')}/"
	MEDIA = f"/Volumes/"
	GROUP = "wheel"

# database.
for dir, permission in [
	[f"{HOME}/.sshmount", 770],
	[f"{HOME}/.sshmount/daemons", 770], ]:
	if not os.path.exists(dir): os.system(f"sudo mkdir {dir} && sudo chown {OWNER}:{GROUP} {dir} && sudo chmod {permission} {dir}")

# files.
DATABASE = Files.Directory(path=f"{HOME}/.sshmount")
CONFIG = Files.Dictionary(path=DATABASE.join("config",""), load=True, default={
	"aliases":{
		"example.com":{
			"user":"administrator",
			"public_ip":"192.168.1.100",
			"public_port":22,
			"private_ip":"84.84.123.192",
			"private_port":22,
			"key":"~/keys/exmaple.com/administrator/private_key",
			"passphrase":None,
		}
	},
	"settings": {
		"keep_alive":60,
	},
})