#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# imports.
from sshmount.classes.config import *

# test ssh connection.
def test_ssh(alias=None, accept_new_host_keys=True):
	if accept_new_host_keys:
		accept_new_host_keys = "printf 'y' | "
	else:
		accept_new_host_keys = ""
	output = syst3m.utils.__execute_script__(f"""{accept_new_host_keys}ssh {alias} ' echo "Hello World" ' """)
	if 'Hello World' not in output:
		return r3sponse.error_response(f"Failed to connect with {alias}, error: {output}.")
	else:
		return r3sponse.success_response(f"Successfully connected with {alias}.")

# test ssh path existance.
def test_ssh_path(alias=None, path=None, accept_new_host_keys=True):
	response = test_ssh(alias, accept_new_host_keys=accept_new_host_keys)
	if not response.success: return response
	output = syst3m.utils.__execute_script__(f"ssh {alias} ' ls -ld {path} ' ")
	if 'No such file or directory' in output:
		return r3sponse.error_response(f"Remote path {alias}:{path} does not exist.")
	else:
		return r3sponse.success_response(f"Successfully checked remote path {alias}:{path}.")

# test sshmount library.
def test_sshmount(alias=None, accept_new_host_keys=True):
	response = test_ssh(alias, accept_new_host_keys=accept_new_host_keys)
	if not response.success: return response
	output = syst3m.utils.__execute_script__(f"ls -ld /usr/local/lib/sshmount")
	if 'No such file or directory' in output:
		return r3sponse.error_response(f"""Remote {alias} does not have library sshmount installed. Install with $ ssh {alias} 'pip3 install sshmount=={syst3m.utils.__load_file__(SOURCE_PATH+"/.version")} ' """)
	else:
		return r3sponse.success_response(f"Successfully checked the sshmount library on remote {alias}.")

# bool to --bool str
def convert_bool(boolean, true="True", false='False'):
	if boolean:
		return true
	else:
		return false
